#ifndef OMSPINBOX_H
#define OMSPINBOX_H
#include <qspinbox.h>
#include <vector>
#include <cstring>
#include <qstring.h>
#include <iostream>
class QWidget;


/**********************************************************************
*
*
*
**********************************************************************/
class OmSpinBox : public QSpinBox
{

  Q_OBJECT

protected:
   
   QString mapValueToText(int v)
   {

    

        if ( v < minValue() || v > maxValue() )
	    return " ";
        else
            return _stringList[v - 1];
   };

public:

    OmSpinBox( QWidget *widget, QString text, vector<string> &theList, int current = 1);
  
    OmSpinBox( QWidget *widget, QString text, int size, vector<string> &theList, int current = 1);
  

private:
    vector<string> _stringList;

};
/**************************************************************
 *
 *
 *************************************************************/
class OmSpinBox2 : public QSpinBox
{

  Q_OBJECT

protected:
   
   QString mapValueToText(int v)
   {
     
        if ( v < minValue() || v > maxValue() )
	    return " ";
        else if( v == minValue())
	{
      
	    QString text;
            text.sprintf("%4.2f", _defaultValue);
            return text;

        }
        else
	{
    
	    float value = _xmin + float( v - 1) * _dx;
	    QString text;
            text.sprintf("%4.2f", value);
            return text;

        }
   };

public:

    OmSpinBox2( QWidget *widget, QString text, float xmin, float 
              xmax, float dx, float defaultValue, int current = 0);
  
    float realValue()
    {
        int index = value();
        if (index == minValue() )
	    return _defaultValue;
        else
           return _xmin + float( index - 1) * _dx;
    };   

private:
   float _xmin, _xmax, _dx, _defaultValue;

};



#endif
