
#ifndef ALLOCATE_H
#define ALLOCATE_H


/***********************************************************************
*                                                                              *
* allocate -- allocates memory for a double array of any type                  *
*                                                                              *
* Parameters -- array - pointer to the array                                   *
*               nrows - number of rows in the array                            *
*               ncolumns - number of columns in the array                      *
********************************************************************************/
template <class kind, class kind1, class kind2>
void allocate(kind ***array, kind1 nrows, kind2 ncolumns)
{
    *array = new kind*[nrows];
  
    for (int j = 0; j < nrows; j++)
        (*array)[j] = new kind[ncolumns];


}


/*******************************************************************************
*                                                                              *
* de_allocate -- de-allocates memory for a double array of any type            *
*                                                                              *
* Parameters -- array - pointer to the array                                   *
*               nrows - number of rows in the array                            *
*               ncolumns - number of columns in the array                      *
********************************************************************************/
template<class kind, class type>
void de_allocate(kind ***array, type nrows)
{
    if (*array == NULL) return;

    for (int i = 0; i < nrows; i++)
    {
        if ((*array)[i]) delete [] (*array)[i];
    }
    delete [] *array;


    *array = NULL;

}
#endif
