/**********************************
* ComputeAverage
* Calculates the weighted average and
* standard deviation 
**********************************/
#include "average.h"
#include <cmath>

float Average::ComputeAverage(const int size, 
              const float* x, const float* dx, 
              float &standardDeviation) 

{    
       
    float mean;  
    
      
    if (size == 1) 
    {
        mean = x[0];
	standardDeviation = dx[0];
	return mean;
    }


      
    
    for (int i = 0; i < size; i++)
    { 
       
        double weight = 1.0 / (dx[i] * dx[i]);
	sum1 += weight;
	sum2 += x[i] * weight;
	sum3 += weight * weight;
    

    }


    mean = sum2 / sum1;  // The mean

  

    for (int i = 0; i < size; i++)
    {
       
   
        double difference = x[i] - mean;       
    
	double weight = 1.0 / (dx[i] * dx[i]);
        sum4 += weight * difference * difference;
       
       
    }

    double d = sum1 - sum3 / sum1;
   
    
    standardDeviation = sqrt(sum4 / d);  //  The standard deviation
    
    return mean;      
}
/*******************************************************
*
*******************************************************/
float Average::UpdateAverage(const float x, 
             const float dx, float& standardDeviation)
{
 
    double weight = 1.0 / dx * dx;

    sum1 += weight;
    sum2 += x * weight;
    sum3 += weight * weight;
    

    float mean = sum2 / sum1;  // The mean

   
    double difference = x - mean;       
    
    sum4 += weight * difference * difference;
       
      
    double d = sum1 - sum3 / sum1;
   
    if (d > 0.0)    
        standardDeviation = sqrt(sum4 / d);  //  The standard deviation
    else
        standardDeviation = 0.0;

    return mean;      
}

float Average::UpdateAverage(const int size, 
              const float* x, const float* dx, 
              float &standardDeviation) 

{    
       
    float mean;  
    
           
    
    for (int i = 0; i < size; i++)
    { 
       
        double weight = 1.0 / (dx[i] * dx[i]);
	sum1 += weight;
	sum2 += x[i] * weight;
	sum3 += weight * weight;
    

    }


    mean = sum2 / sum1;  // The mean

  

    for (int i = 0; i < size; i++)
    {
       
   
        double difference = x[i] - mean;       
    
	double weight = 1.0 / (dx[i] * dx[i]);
        sum4 += weight * difference * difference;
       
       
    }

    double d = sum1 - sum3 / sum1;
   
   
  
    if (d > 0.0)    
        standardDeviation = sqrt(sum4 / d);  //  The standard deviation
    else
        standardDeviation = 0.0;



    
    return mean;      
}

