// -*-C++-*-
//
// File:      omsource.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 17:05:36 MEST 2002
#include "omsource.h"
#include "OmSource.h" // gui
#include "param.h"
#include "Dal.h"
#include <errstr.h>
#include <cstring>
void checkFiles();
void omsource()
{
   
    checkFiles();   
    //    cout << "omsource.cc line 19\n";

    OmSource gui;
    //   cout << "omsource.cc line 22\n";

    gui.exec();

    // cout << "omsource.cc line 28\n";

};
/************************************************************************
*
************************************************************************/
void checkFiles()
{

    string image = stringParameter("imageset");
    if( image.length() < 3) return;



    string srcList = stringParameter("oldsrclistset");
    if( srcList.length() < 3) return;



    if (image == srcList)
    {
        Sas::fatal("IdenticalFiles", image);


    }


    DataSet *set = dataSetServer->open(image, Dal::Read);


    if(!set)
    {

        Sas::fatal("Could not read image file", image);

    }
    string expId = "";
    if (set->hasAttribute("EXP_ID") )
    {
        expId = set->attribute("EXP_ID")->asString();
    }
 
    dataSetServer->close(set);

  
 
    set = dataSetServer->open(srcList, Dal::Read);

    if (!set)
    {
        Sas::fatal("Could not read source-list file", srcList);

     
    }
    
    string expId1 = "";
    if (set->hasAttribute("EXP_ID") )
    {
        expId1 = set->attribute("EXP_ID")->asString();
    }
 


    if(expId != expId1)
    {

        dataSetServer->close(set);

        Sas::fatal("Incompatible image and source-list  files", image);

       

    }

    dataSetServer->close(set);


  
}


